import java.util.*;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

import sample3.Sample3;
import sample3.Sample3Home;

public class Sample3Client
{

  public static void main(String[] args)
  {
    String textMessage = "Default text message";
    String correlID;

    // check if a string was provided on the command line
    if (args.length > 0) {
      textMessage = args[0];
    }

    try {
      // Connect to the WebSphere service provider via JNDI
      Hashtable env = new Hashtable();
      env.put( Context.INITIAL_CONTEXT_FACTORY, "com.ibm.ejs.ns.jndi.CNInitialContextFactory" );
      env.put( Context.PROVIDER_URL, "iiop://localhost/" ); // Modify if server is non-local
      Context initial = new InitialContext(env);

      // Lookup the EJB home
      Object objref = initial.lookup("jmsSample3");
      Sample3Home home = 
        (Sample3Home)PortableRemoteObject.narrow(objref, Sample3Home.class);

      // Create the stub to talk to the EJB
      Sample3 testBean = home.create();

      // Need to have a durable subscription before we publish the message
      System.out.println("creating durable subscription");
      testBean.createSubscription();

      // Now we can publish
      System.out.println("calling putMessage");
      correlID = testBean.putMessage(textMessage);

      // And recive the message via a subscriber
      System.out.println("calling getMessage");
      String response = testBean.getMessage();

      System.out.println("got message '"+response+"'");

      // Remove the durable subscription
      System.out.println("deleting durable subscription");
      testBean.destroySubscription();

      System.out.println("done");

    } catch (Exception ex) {
      System.err.println("Caught an unexpected exception: "+ex);
      ex.printStackTrace();
    }
  }
}
